#!/usr/bin/env python
# Row and column name tester. See readme.txt for instructions.

import sys
import ods

# converts 0-based index to a typical spreadsheet-like cell name
# (1=A, 2=B, ..., 26=Z, 27=AA, 28=AB, and so on)
# yeah, this could be better
def cell_name(n):
    if n > 701:
        return "-"
    elif n < 26:
        return chr(n + 65)
    else:
        a, b = divmod(n, 26)
        return "%s%s" % (chr(a + 64), chr(b + 65))


if len(sys.argv) != 2:
    quit("Usage: testods.py <ODS file>")

sheets = ods.load_ods(sys.argv[1])

for sheet in sheets.items():
    for row_num, row_data in sheet[1].items():
        for col_num, col_data in row_data.items():
            notation = "%s%d" % (cell_name(col_num - 1), row_num)

            if notation != col_data:
                print("MISMATCH: %s != %s" % (col_data, notation))
